unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, _Osoba, ComCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    btnBrak: TButton;
    btnDete: TButton;
    Ime: TLabel;
    btnShow: TButton;
    TreeView1: TTreeView;
    procedure btnDeteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnBrakClick(Sender: TObject);
    procedure btnShowClick(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
  private
    { Private declarations }
    FKoren: TOsoba;
    FTemp: TOsoba;
  public
    { Public declarations }
    procedure ShowStablo;
  end;

var
  Form1: TForm1;

implementation

uses _dlgOsoba;

{$R *.dfm}

procedure TForm1.btnDeteClick(Sender: TObject);
var
  aDete: TOsoba;
begin
  with TdlgOsoba.Create(nil) do
  begin
    Caption := self.Edit1.Text + ' novo dete: ';

    if ShowModal = mrOk then
    begin
      aDete := TOsoba.Create;
      aDete.Ime := edtIme.Text;
      aDete.Musko := chkMusko.Checked;

      FTemp.NovoDete( aDete);

      ShowStablo;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FKoren := TOsoba.Create;
  FKoren.Ime := 'deda Miloje';
  FKoren.Musko := true;

  FTemp := FKoren;

  self.Edit1.Text := FKoren.Ime;

end;

procedure TForm1.btnBrakClick(Sender: TObject);
var
  aPartner: TOsoba;
begin
  with TdlgOsoba.Create(nil) do
  begin
    Caption := self.Edit1.Text + ' brak: ';
    if ShowModal = mrOk then
    begin
      aPartner := TOsoba.Create;
      aPartner.Ime := edtIme.Text;
      aPartner.Musko := chkMusko.Checked;

      FTemp.BrakSa( aPartner);

      ShowStablo;
    end;
  end;
end;

procedure TForm1.btnShowClick(Sender: TObject);
begin
  showStablo;
end;

procedure TForm1.TreeView1Click(Sender: TObject);
begin
  if self.TreeView1.Selected = nil then exit;

  FTemp := TOsoba( TreeView1.Selected.Data);
  self.Edit1.Text := FTemp.Ime;
end;

procedure TForm1.ShowStablo;

  function DodajOsobu( aParentNode: TTreeNode; aOsoba: TOsoba): TTreeNode;
  begin
    Result := TreeView1.Items.AddChildObject( aParentNode,
       aOsoba.Ime + ' : '+ aOsoba.ImePartnera, aOsoba);
  end;

  function DodajDecu( aRoot: TTreeNode; aOsoba: TOsoba): TTreeNode;
  var
    i: integer;
    aDete: TOsoba;
    aBrakNode, aDeteNode: TTreeNode;
  begin
    Result := DodajOsobu( aRoot, aOsoba);

    // dodaje decu za datu aOsoba instancu:
    if assigned( aOsoba.Deca) then
      for i:=0 to aOsoba.Deca.Count-1 do
      begin
        aDete := TOsoba( aOsoba.Deca.Objects[i]);
        // opet poziv metode sa istim nazivom: DodajDecu?
        // ovo je tzv rekurzija:
        // za svako dete, dodaj njegovu decu...
        DodajDecu( Result, aDete);
      end;
  end;

begin
  with TreeView1 do
  begin
    Items.Clear;
    DodajDecu( nil, FKoren);
  end;
end;


end.
