unit _Osoba;

interface

uses Classes;

type
  TOsoba = class( TObject)
  private
    FPartner: TOsoba;
    FDeca: TStringList;
    function GetImePartera: string;
  private
    FMusko: boolean;
    FIme: string;
  public
    constructor Create; 
  public
    property Ime: string read FIme write FIme;
    procedure BrakSa( aNovPartner: TOsoba);
    procedure NovoDete ( aDete: TOsoba);
    property Musko: boolean read FMusko write FMusko; // true, false
  public
    property ImePartnera: string read GetImePartera;
    property Deca: TStringList read FDeca;
  end;

implementation

{ TOsoba }

uses Dialogs;

procedure TOsoba.BrakSa(aNovPartner: TOsoba);
begin
  assert( (FPartner = nil), 'Partner postoji');
  assert( (aNovPartner.Musko <> self.Musko), 'Partner mora da bude suprotnog pola!');

  // posto smo proverili uslove, dodeljumo novog partnera:

  FPartner := aNovPartner;
end;

constructor TOsoba.Create;
begin
  Fime := '';
  FMusko := true;
  FPartner := nil;
  FDeca := nil;
end;

function TOsoba.GetImePartera: string;
begin
  if Assigned( FPartner) then
    Result := FPartner.Ime
  else
    Result := '';
end;

procedure TOsoba.NovoDete( aDete: TOsoba);
begin
  assert( assigned( FPartner), 'Partner nije naveden, ne mogu imati decu!');

  if not assigned( FDeca) then
    FDeca := TStringList.Create;  // <--- jednostavno: spisak dece!

  FDeca.AddObject( aDete.Ime, aDete);
end;

end.
